"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.decorate = decorate;
const index_js_1 = require("../helpers/index.js");
const meta_js_1 = require("./meta.js");
function decorate(rule) {
    return (0, index_js_1.interceptReport)({
        ...rule,
        meta: (0, index_js_1.generateMeta)(meta_js_1.meta, rule.meta),
    }, (context, descriptor) => {
        const { node } = descriptor;
        const moduleKeyword = context.sourceCode.getFirstToken(node, token => token.value === 'module');
        if (moduleKeyword?.loc) {
            context.report({ ...descriptor, loc: moduleKeyword.loc });
        }
        else {
            context.report(descriptor);
        }
    });
}
