"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.decorate = decorate;
const index_js_1 = require("../helpers/index.js");
const meta_js_1 = require("./meta.js");
function decorate(rule) {
    return (0, index_js_1.interceptReportForReact)({
        ...rule,
        meta: (0, index_js_1.generateMeta)(meta_js_1.meta, rule.meta),
    }, reportExempting(hasSpreadOperator));
}
function reportExempting(exemptionCondition) {
    return (context, reportDescriptor) => {
        // check if node has attribute containing spread operator
        if ('node' in reportDescriptor) {
            const { node, ...rest } = reportDescriptor;
            if (exemptionCondition(node)) {
                return;
            }
            context.report({
                node,
                ...rest,
            });
        }
    };
}
function hasSpreadOperator(node) {
    return (node.type === 'JSXElement' &&
        node.openingElement.attributes.some(attribute => attribute.type === 'JSXSpreadAttribute'));
}
