"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.rule = void 0;
const index_js_1 = require("../core/index.js");
const decorator_js_1 = require("./decorator.js");
const posix_1 = require("path/posix");
const index_js_2 = require("../helpers/index.js");
const decorated = (0, decorator_js_1.decorate)(index_js_1.eslintRules['prefer-object-spread']);
exports.rule = {
    meta: decorated.meta,
    create(context) {
        // https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Operators/Spread_syntax#browser_compatibility
        if (!(0, index_js_2.isSupported)((0, posix_1.dirname)((0, index_js_2.toUnixPath)(context.filename)), { node: '8.3.0' })) {
            return {};
        }
        return decorated.create(context);
    },
};
