"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.decorate = decorate;
const index_js_1 = require("../helpers/index.js");
const jsx_ast_utils_1 = __importDefault(require("jsx-ast-utils"));
const { hasAnyProp } = jsx_ast_utils_1.default;
const meta_js_1 = require("./meta.js");
/**
 * This fix was introduced in eslint-plugin-jsx-a11y e6bfd5cb7c,
 * but the last release is almost a year old, so it doesn't include this.
 * When we update the dependency, we can remove this decorator.
 *
 * This will include the removal of:
 * - the `jsx-ast-utils` dependency
 * - its type definition `typings/jsx-ast-utils/index.d.ts`
 * - all files in the `rules/S6827/` directory
 */
function decorate(rule) {
    return (0, index_js_1.interceptReport)({
        ...rule,
        meta: (0, index_js_1.generateMeta)(meta_js_1.meta, {
            ...rule.meta,
            hasSuggestions: true,
        }),
    }, (context, reportDescriptor) => {
        const node = reportDescriptor.node;
        if (hasAnyProp(node.attributes, ['title', 'aria-label'])) {
            return;
        }
        context.report({ ...reportDescriptor });
    });
}
