/**
 * This is the entry point of the ESLint Plugin.
 * Said differently, this is the public API of the ESLint Plugin.
 */
import type { Rule, Linter } from 'eslint';
export declare const rules: Record<string, Rule.RuleModule>;
export declare const configs: {
    recommended: Linter.FlatConfig<Linter.RulesRecord> & {
        rules: Linter.RulesRecord;
    };
    'recommended-legacy': Linter.Config<Linter.RulesRecord, Linter.RulesRecord>;
};
/**
 * I kept the meta export for compatibility, but we need to find a way to populate it without relying on the package manifest
 */
export declare const meta: {
    name: string;
    version: string;
};
declare const _default: {
    rules: Record<string, Rule.RuleModule>;
    configs: {
        recommended: Linter.FlatConfig<Linter.RulesRecord> & {
            rules: Linter.RulesRecord;
        };
        'recommended-legacy': Linter.Config<Linter.RulesRecord, Linter.RulesRecord>;
    };
    meta: {
        name: string;
        version: string;
    };
};
export default _default;
